;       cpu  Z80UNDOC

;       RELAXED ON

         
;RUSSIAN KEMPSTON MOUSE DRIVER

	org #8000         

	output kmdrvshortENIGMA.bin

XMAX     equ  #F0
XMIN     equ  0
         
YMAX     equ  #B1
YMIN     equ  #48
         
;XECUTE MOUSE
;TAKE COORDINATES FROM CURPOS=
;=COORD
         
MOUSE    
         ld   hl,(COORD)
;L=X-axis
;H=Y-axis
         ld   bc,$FBDF
         ld   de,(OLDCO)
         in   a,(c)
         ld   (OLDCO),a
         sub  e
         jr   z,NM_X
         jp   p,MX_PL
         add  a,l
         jr   c,ZER_X
         xor  a
ZER_X    ld   l,a
         jr   NM_X
MX_PL    add  a,l
         jr   c,BEX_Z
         cp   XMAX
         jr   c,BEX_B
BEX_Z    ld   a,XMAX
BEX_B    ld   l,a
NM_X     ld   b,$FF
         in   a,(c)
         ld   (OLDCO+1),a
         sub  d
         jr   z,NM_Y
         neg  
         jp   p,MY_PL
         add  a,h
         jr   c,ZER_Y
         xor  a
ZER_Y    ld   h,a
         jr   NM_Y
MY_PL    add  a,h
         jr   c,BEY_Z
         cp   YMAX
         jr   c,BEY_B
BEY_Z    ld   a,YMAX
BEY_B    ld   h,a
NM_Y     ld   a,h
         cp   $FF
         jr   c,BIGY
         ld   h,$FF
BIGY     cp   YMIN
         jr   nc,SMALY
         ld   h,YMIN
SMALY    ld   a,l
         cp   $FF
         jr   c,DIRY
         ld   l,$FF
DIRY     cp   XMIN
         jr   nc,DIMENS
         ld   l,XMIN
DIMENS   ld   (COORD),hl
         ld   bc,$FADF
         in   a,(c)
         cpl  
         and  7
         ld   (CONTRB),a
         ret  
;------------------------------
;INPUT: L=new X-axis
;       H=new Y-axis
         
KOREKCE  ld   a,$FB
         in   a,($DF)
         ld   (OLDCO),a
         ld   a,$FF
         in   a,($DF)
         ld   (OLDCO+1),a
         ld   (COORD),hl
         ret  
;------------------------------
;new cursor position
COORD    defb 0,0
         
;buttons status
CONTRB   defb 0
         
;working (previous position)
OLDCO    defb 0,0
;------------------------------
LENGTH   equ  $-MOUSE

adr_ovl	dw #55		;zde je adresa ovladaci rutiny (keyboard, kempst,sinclair... da ji sem
			;hlavni program, rutina F11F (musi se ji vnutit tato adresa)
		
TST_PR	call #8000	;test jen praveho tlacitka, out=NZ, stisteno prave
	ret z
	cp 2
	ret z
	ld a,#E
	ld (#8DDB),a
	ret	

KOR	ld hl,(#8DD1)	;pro uvod hry, aby krizek nesvitil x krat na obrazovce
	call KOREKCE
	ld hl,TST_MAIN
	ld (#901C),hl
	ld hl,(adr_ovl)
	ld (#82C5),hl
	jp #8DF1

TST_MAIN call #8000	;vystup musi byt Z=nic nestisteno, NZ=stisteno
	jr z,tst_cor	
	cp 2
	jr nz,tst_rgh
	ld e,9		;left fire
	jr write
tst_rgh cp 1		;pravy fire (hodnota E pro vyskok z manualu) nelze v hlavni rutine delat
	jr z,wr_zero	;tak ho nebudeme vracet
tst_cor ld (#8DD5),hl
	ld a,l
	or a
	jr nz,rght
	ld e,3
	jr write
rght	cp #F0
	jr nz,no_key
	ld e,6
	jr write
no_key	call #903E		;je to v original hre a my to preskakujeme, melo by to tu byt
wr_zero	ld e,0
write	xor a
	add a,e
wr_e	ld (#8DDB),a
	ret